#ifndef INCLUDED__IMAGE__FLIP__H
#define INCLUDED__IMAGE__FLIP__H

#include <cstdint>

// Class to flip an image about its veritcal axis (horiztonally).
class HorizontalFlip8
{
private:
    std::uint32_t m_width;
    std::uint32_t m_height;

    int m_blockSizeX;
    int m_blockSizeY;
    int m_threadCount;
    std::uint32_t m_stepCount;
    std::uint32_t m_wordStep;

    // Illegal.
    HorizontalFlip8 (void);
    HorizontalFlip8 (HorizontalFlip8 const&);
    HorizontalFlip8& operator= (HorizontalFlip8 const&);

public:
    // Initialize with the given width and height.
    HorizontalFlip8 (const std::uint32_t a_width, const std::uint32_t a_height);

    // Reinitialize with the given width and height.
    void setFrameParams (const std::uint32_t a_width, const std::uint32_t a_height);

    // Kernel to flip an input about the vertical access (left <--> right). The image width should
    // be multiple of 32-bits.
    void flip (const std::uint8_t *const devImgIn, std::uint8_t *const devImgOut) const;
};

#endif // INCLUDED__IMAGE__FLIP__H
